;; -*- lexical-binding: t -*-
(require 'seq)

(defun my-contains-some (sequence elt &optional testfn)
  (or testfn (setq testfn #'equal))
  (seq-some (lambda (e)
              (funcall testfn elt e))
            sequence))

(defun my-contains-posn (sequence elt &optional testfn)
  (seq-position sequence elt testfn))

(let* ((reps 10000)
       (needle 50)
       (haystack (number-sequence 1 needle)))
  (dolist (fn '(my-contains-posn my-contains-some))
    (garbage-collect)
    (message "%s: %s" fn (benchmark-run reps
                           (funcall fn haystack needle)))))
